# WARNING: Please don't edit this file. It was generated by Python/WinRT v2.2.0

import datetime
import sys
import types
import typing
import uuid as _uuid
from builtins import property as _property

import winrt._winrt
import winrt.system
import winrt.windows.devices.bluetooth as windows_devices_bluetooth
import winrt.windows.devices.enumeration as windows_devices_enumeration
import winrt.windows.foundation as windows_foundation
import winrt.windows.foundation.collections as windows_foundation_collections
import winrt.windows.networking as windows_networking
import winrt.windows.networking.sockets as windows_networking_sockets
import winrt.windows.storage.streams as windows_storage_streams

Self = typing.TypeVar('Self')

@typing.final
class RfcommDeviceService_Static(type):
    def from_id_async(cls, device_id: str, /) -> windows_foundation.IAsyncOperation[RfcommDeviceService]: ...
    def get_device_selector(cls, service_id: typing.Optional[RfcommServiceId], /) -> str: ...
    @typing.overload
    def get_device_selector_for_bluetooth_device(cls, bluetooth_device: typing.Optional[windows_devices_bluetooth.BluetoothDevice], /) -> str: ...
    @typing.overload
    def get_device_selector_for_bluetooth_device(cls, bluetooth_device: typing.Optional[windows_devices_bluetooth.BluetoothDevice], cache_mode: windows_devices_bluetooth.BluetoothCacheMode, /) -> str: ...
    @typing.overload
    def get_device_selector_for_bluetooth_device_and_service_id(cls, bluetooth_device: typing.Optional[windows_devices_bluetooth.BluetoothDevice], service_id: typing.Optional[RfcommServiceId], /) -> str: ...
    @typing.overload
    def get_device_selector_for_bluetooth_device_and_service_id(cls, bluetooth_device: typing.Optional[windows_devices_bluetooth.BluetoothDevice], service_id: typing.Optional[RfcommServiceId], cache_mode: windows_devices_bluetooth.BluetoothCacheMode, /) -> str: ...

@typing.final
class RfcommDeviceService(winrt.system.Object, metaclass=RfcommDeviceService_Static):
    def __enter__(self: Self) -> Self: ...
    def __exit__(self, *args) -> None: ...
    @staticmethod
    def _from(obj: winrt.system.Object, /) -> RfcommDeviceService: ...
    def close(self) -> None: ...
    @typing.overload
    def get_sdp_raw_attributes_async(self) -> windows_foundation.IAsyncOperation[windows_foundation_collections.IMapView[winrt.system.UInt32, windows_storage_streams.IBuffer]]: ...
    @typing.overload
    def get_sdp_raw_attributes_async(self, cache_mode: windows_devices_bluetooth.BluetoothCacheMode, /) -> windows_foundation.IAsyncOperation[windows_foundation_collections.IMapView[winrt.system.UInt32, windows_storage_streams.IBuffer]]: ...
    def request_access_async(self) -> windows_foundation.IAsyncOperation[windows_devices_enumeration.DeviceAccessStatus]: ...
    @_property
    def connection_host_name(self) -> typing.Optional[windows_networking.HostName]: ...
    @_property
    def connection_service_name(self) -> str: ...
    @_property
    def max_protection_level(self) -> windows_networking_sockets.SocketProtectionLevel: ...
    @_property
    def protection_level(self) -> windows_networking_sockets.SocketProtectionLevel: ...
    @_property
    def service_id(self) -> typing.Optional[RfcommServiceId]: ...
    @_property
    def device(self) -> typing.Optional[windows_devices_bluetooth.BluetoothDevice]: ...
    @_property
    def device_access_information(self) -> typing.Optional[windows_devices_enumeration.DeviceAccessInformation]: ...

@typing.final
class RfcommDeviceServicesResult(winrt.system.Object):
    @staticmethod
    def _from(obj: winrt.system.Object, /) -> RfcommDeviceServicesResult: ...
    @_property
    def error(self) -> windows_devices_bluetooth.BluetoothError: ...
    @_property
    def services(self) -> typing.Optional[windows_foundation_collections.IVectorView[RfcommDeviceService]]: ...

@typing.final
class RfcommServiceId_Static(type):
    def from_short_id(cls, short_id: winrt.system.UInt32, /) -> typing.Optional[RfcommServiceId]: ...
    def from_uuid(cls, uuid: _uuid.UUID, /) -> typing.Optional[RfcommServiceId]: ...
    @_property
    def generic_file_transfer(cls) -> typing.Optional[RfcommServiceId]: ...
    @_property
    def obex_file_transfer(cls) -> typing.Optional[RfcommServiceId]: ...
    @_property
    def obex_object_push(cls) -> typing.Optional[RfcommServiceId]: ...
    @_property
    def phone_book_access_pce(cls) -> typing.Optional[RfcommServiceId]: ...
    @_property
    def phone_book_access_pse(cls) -> typing.Optional[RfcommServiceId]: ...
    @_property
    def serial_port(cls) -> typing.Optional[RfcommServiceId]: ...

@typing.final
class RfcommServiceId(winrt.system.Object, metaclass=RfcommServiceId_Static):
    @staticmethod
    def _from(obj: winrt.system.Object, /) -> RfcommServiceId: ...
    def as_short_id(self) -> winrt.system.UInt32: ...
    def as_string(self) -> str: ...
    @_property
    def uuid(self) -> _uuid.UUID: ...

@typing.final
class RfcommServiceProvider_Static(type):
    def create_async(cls, service_id: typing.Optional[RfcommServiceId], /) -> windows_foundation.IAsyncOperation[RfcommServiceProvider]: ...

@typing.final
class RfcommServiceProvider(winrt.system.Object, metaclass=RfcommServiceProvider_Static):
    @staticmethod
    def _from(obj: winrt.system.Object, /) -> RfcommServiceProvider: ...
    @typing.overload
    def start_advertising(self, listener: typing.Optional[windows_networking_sockets.StreamSocketListener], /) -> None: ...
    @typing.overload
    def start_advertising(self, listener: typing.Optional[windows_networking_sockets.StreamSocketListener], radio_discoverable: bool, /) -> None: ...
    def stop_advertising(self) -> None: ...
    @_property
    def sdp_raw_attributes(self) -> typing.Optional[windows_foundation_collections.IMap[winrt.system.UInt32, windows_storage_streams.IBuffer]]: ...
    @_property
    def service_id(self) -> typing.Optional[RfcommServiceId]: ...

